%title="Spectral Analysis"
%window="Smoothing Window:"
%menu = """Hamming"" ""Hann""  Bartlett Parzen Rectangular"
%bandwidth="20"
%myname="                                                                                                                                                                                               Written by:                                         Nicolas Ronderos Pulido (2022)."
%name = _this.@name
scalar check1=5
scalar check2=1
scalar check3=1
scalar check4=1
scalar check5=0
scalar check6=0
scalar check7=0
scalar check8=0
scalar check9=0
scalar check10=0

'Arguments for command line
%truncation=@equaloption("Truncation")
%o_table=@str(@hasoption("Table"))
%window_1=@str(@hasoption("Hamming"))
%window_2=@str(@hasoption("Hann"))
%window_3=@str(@hasoption("Bartlett"))
%window_4=@str(@hasoption("Parzen"))
%window_5=@str(@hasoption("Rectangular"))
%option_1=@str(@hasoption("Coherence"))
%option_2=@str(@hasoption("Gain"))
%option_3=@str(@hasoption("Phase_Shift"))
%option_4=@str(@hasoption("Phase"))
%option_5=@str(@hasoption("Amplitude"))
%option_6=@str(@hasoption("Cospectrum"))
%option_7=@str(@hasoption("Quadrature"))
%option_8=@str(@hasoption("All"))
%option_9=@str(@hasoption("BC"))

%arguments=%o_table+%window_1+%window_2+%window_3+%window_4+%window_5+%option_1+%option_2+%option_3+%option_4+%option_5+%option_6+%option_7+%option_8+%option_9
%arguments1=%truncation

if %arguments="000000000000000" and %arguments1="" then  'if none arguments were provided
	!result = @uidialog("edit", %name,"Group of Variables:","edit",%bandwidth,"Truncation point:","Check",check10,"Bias Correction","Check",check9,"Output table","radio",check1,%window,%menu,"Check",check2,"Coherence","Check",check3,"Gain","Check",check4,"Phase Shift","Check",check5,"Phase Spectrum","Check",check6,"Amplitude Spectrum","Check",check7,"Cospectrum","Check",check8,"Quadrature Spectrum","Caption",%title,"text",%myname)
	
	if !result=-1 then
		delete check1 check2 check3 check4 check5 check6 check7 check8 check9 check10
		stop
	endif
	
	if %name="" then
		@uiprompt("Please enter a group object")
		delete check1 check2 check3 check4 check5 check6 check7 check8 check9 check10
		stop
	endif
	
	if %bandwidth="" then
		@uiprompt("You must enter a truncation value")
		delete check1 check2 check3 check4 check5 check6 check7 check8 check9 check10
		stop
	endif
	
	if @val(%bandwidth)<=0 then
		@uiprompt("The truncation must be positive")
		delete check1 check2 check3 check4 check5 check6 check7 check8 check9 check10
		stop
	endif
	
	if @val(%bandwidth)>@rows({%name})/2 then
		@uiprompt("The truncation point is too large")
		delete check1 check2 check3 check4 check5 check6 check7 check8 check9 check10
		stop
	endif
	
else 'If some arguments were introduced
	
	if %truncation<>"" then 'Default 20
		%bandwidth=%truncation   
	endif
	if %o_table<>"1" then
		check9=0
	endif
	if %window_1="1" then  'Default Rectangular
		check1=1
	endif
	if %window_2="1" then  'Default Rectangular
		check1=2
	endif
	if %window_3="1" then  'Default Rectangular
		check1=3
	endif
	if %window_4="1" then  'Default Rectangular
		check1=4
	endif
	if %window_5="1" then  'Default Rectangular
		check1=5
	endif
	if %option_1="1" then 'With this option by default
		check2=1
	endif
	if %option_2<>"1" then 'Without this option by default
		check3=0
	endif
	if %option_3<>"1" then 'Without this option by default
		check4=0
	endif
	if %option_4="1" then 'Without this option by default
		check5=1
	endif
	if %option_5="1" then 'Without this option by default
		check6=1
	endif
	if %option_6="1" then 'Without this option by default
		check7=1
	endif
	if %option_7="1" then 'Without this option by default
		check8=1
	endif
	if %option_8="1" then 'Without this option by default
		check2=1
		check3=1
		check4=1
		check5=1
		check6=1
		check7=1
		check8=1
	endif
	if %option_9<>"1" then 'With this option by default
		check10=0
	endif
	
endif

for !i=1 to 5
	if check1=!i then
		%choosen_window=@word("Hamming Hann Bartlett Parzen Rectangular",!i)
	endif
next

''---------------------------------------------------------------------------Bivariate Spectrum----------------------------------------------------------------------------------
if check6=1 then
	group amplitude
endif

if check5=1 then
	group phase
endif

if check4=1 then
	group phase_s
endif

if check7=1 then
	group cospectrum
endif

if check8=1 then
	group quadrature
endif

if check10=1 then
	!z=0
	%lag_lead=""
endif

for !l=1 to @columns({%name})
	for !h=1 to @columns({%name})
		!LAG_LEAD=0
		vector cospectrum_!l_!h
		vector quadrature_!l_!h
		vector w_!l_!h
		vector frec_!l_!h
		group group {%name}
		call cross_spectra(group,cospectrum_!l_!h,quadrature_!l_!h,w_!l_!h,frec_!l_!h,check1,!l,!h,@val(%bandwidth),check10,!LAG_LEAD)
		if check10=1 then
			!z=!z+1
			%lag_lead=%lag_lead+" "+@str(!LAG_LEAD)
		endif
		mtos(cospectrum_!l_!h,cospectrum1_!l_!h)
		mtos(quadrature_!l_!h,quadrature1_!l_!h)
		mtos(w_!l_!h,angular_!l_!h)
		mtos(frec_!l_!h,frequency_!l_!h)
		if check7=1 then
			group cospectrum cospectrum frequency_!l_!h cospectrum1_!l_!h
		endif
		if check8=1 then
			group quadrature quadrature frequency_!l_!h quadrature1_!l_!h
		endif
		'Cross Amplitude Spectrum
		if check6=1 or check2=1 or check3=1 then
			genr A_!l_!h=@sqrt(cospectrum1_!l_!h^2+quadrature1_!l_!h^2)
			if check6=1 then
				group amplitude amplitude frequency_!l_!h A_!l_!h
			endif
		endif
		'Phase spectrum
		if check5=1 or check4=1 then
			genr phase_!l_!h=@atan((-quadrature1_!l_!h)/cospectrum1_!l_!h)
			if check5=1 then
				group phase phase frequency_!l_!h phase_!l_!h
			endif
		endif
		'Phase spectrum shift
		if check4=1 then
			genr phase_shift_!l_!h=phase_!l_!h/angular_!l_!h
			group phase_s phase_s frequency_!l_!h phase_shift_!l_!h
		endif
		delete  frec_!l_!h cospectrum_!l_!h quadrature_!l_!h group w_!l_!h
	next
next

'-------------------------------------------------------------------------------------------Graphs--------------------------------------------------------------------------------
%spool1="Spectral_Graphs"

if @isobject(%spool1) then
	%spool1=@getnextname(%spool1)
endif
spool {%spool1}
{%spool1}.options -tree borders comments margins

%graph1="Amplitude"
%graph2="Phase"
%graph3="Phase_S"
%graph4="Cospectrum"
%graph5="Quadrature"

if @isobject(%graph1) then
	%graph1=@getnextname(%graph1)
endif

if @isobject(%graph2) then
	%graph2=@getnextname(%graph2)
endif

if @isobject(%graph3) then
	%graph3=@getnextname(%graph3)
endif

if @isobject(%graph4) then
	%graph4=@getnextname(%graph4)
endif

if @isobject(%graph5) then
	%graph5=@getnextname(%graph5)
endif

if check6=1 then
	freeze({%graph1}) amplitude.xyline(m,mult=p)
	{%graph1}.axis(bottom) -invert range(minmax)
	{%graph1}.options gridl
	{%spool1}.insert(name={%graph1}) {%graph1}
	if check10=1 then
		%text_1="Amplitude Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Amplitude Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool1}.comment {%graph1} %text_1
	delete amplitude {%graph1}
endif

if check5=1 then
	freeze({%graph2}) phase.xyline(m,mult=p)
	{%graph2}.axis(bottom) -invert range(minmax)
	{%graph2}.options gridl
	{%spool1}.insert(name={%graph2}) {%graph2}
	if check10=1 then
		%text_1="Phase Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Phase Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool1}.comment {%graph2} %text_1
	delete phase {%graph2}
endif

if check4=1 then
	freeze({%graph3}) phase_s.xyline(m,mult=p)
	{%graph3}.axis(bottom) -invert range(minmax)
	{%graph3}.options gridl
	{%spool1}.insert(name={%graph3}) {%graph3}
	if check10=1 then
		%text_1="Phase Shift Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Phase Shift Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool1}.comment {%graph3} %text_1
	delete phase_s {%graph3}
endif

if check7=1 then
	freeze({%graph4}) cospectrum.xyline(m,mult=p)
	{%graph4}.axis(bottom) -invert range(minmax)
	{%graph4}.options gridl
	{%spool1}.insert(name={%graph4}) {%graph4}
	if check10=1 then
		%text_1="Cospectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Cospectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool1}.comment {%graph4} %text_1
	delete cospectrum {%graph4}
endif

if check8=1 then
	freeze({%graph5}) quadrature.xyline(m,mult=p)
	{%graph5}.axis(bottom) -invert range(minmax)
	{%graph5}.options gridl
	{%spool1}.insert(name={%graph5}) {%graph5}
	if check10=1 then
		%text_1="Quadrature Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Quadrature Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool1}.comment {%graph5} %text_1
	delete quadrature {%graph5}
endif

'-----------------------------------------------------------------------------------Gain and Coherence------------------------------------------------------------------------

if check3=1 then
	group gain
endif

if check2=1 then
	group coherence
endif

for !l=1 to @columns({%name})
	for !h=1 to @columns({%name})
		'Gain
		if check3=1 then
			genr gain_!l_!h=A_!l_!h/A_!l_!l
			group gain gain frequency_!l_!h gain_!l_!h 
		endif
		'Coherence
		if check2=1 then
			genr coherence_!l_!h=(@abs(A_!l_!h)^2)/(A_!l_!l*A_!h_!h)
			group coherence coherence frequency_!l_!h coherence_!l_!h
		endif
	next
next

'----------------------------------------------------------------------------------------Graphs-------------------------------------------------------------------------------------
%graph6="Gain"
%graph7="Coherence"

if @isobject(%graph6) then
	%graph6=@getnextname(%graph6)
endif

if @isobject(%graph7) then
	%graph7=@getnextname(%graph7)
endif

if check3=1 then
	freeze({%graph6}) gain.xyline(m,mult=p)
	{%graph6}.axis(bottom) -invert range(minmax)
	{%graph6}.options gridl
	{%spool1}.insert(name={%graph6}) {%graph6}
	if check10=1 then
		%text_1="Gain Function on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Gain Function on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool1}.comment {%graph6} %text_1
	delete gain {%graph6}
endif

if check2=1 then
	freeze({%graph7}) coherence.xyline(m,mult=p)
	{%graph7}.axis(bottom) -invert range(minmax)
	{%graph7}.options gridl
	{%spool1}.insert(name={%graph7}) {%graph7}
	%text_1="Coherence on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	if check10=1 then
		%text_1="Coherence on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Coherence on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool1}.comment {%graph7} %text_1
	delete coherence {%graph7}
endif

'------------------------------------------------------------------------------------Output tables---------------------------------------------------------------------------------
if check9=1 then
	'Spool for saving all tables
	%spool2="Spectral_Data"
	
	if @isobject(%spool2) then
		%spool2=@getnextname(%spool2)
	endif
	spool {%spool2}
	{%spool2}.options tree borders margins comments
	
	'Coherence,gain,phase shift, phase spectrum, amplitude spectrum,cospectrum, quadrature spectrum, angular frequency,frequency and cycle frequency tables
	
	%table1="Angular_Data"
	if @isobject(%table1) then
		%table1=@getnextname(%table1)
	endif
	table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table1}
	{%table1}.setwidth(@all) 32
	{%table1}.setheight(1) 2
	{%table1}.setfillcolor(1) @rgb(9, 79, 164)
	{%table1}.settextcolor(1) white
	{%table1}.setlines(@all) +a
	
	%table2="Frequency_Data"
	if @isobject(%table2) then
		%table2=@getnextname(%table2)
	endif
	table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table2}
	{%table2}.setwidth(@all) 32
	{%table2}.setheight(1) 2
	{%table2}.setfillcolor(1) @rgb(9, 79, 164)
	{%table2}.settextcolor(1) white
	{%table2}.setlines(@all) +a
	
	%table3="Cycle_Data"
	if @isobject(%table3) then
		%table3=@getnextname(%table3)
	endif
	table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table3}
	{%table3}.setwidth(@all) 32
	{%table3}.setheight(1) 2
	{%table3}.setfillcolor(1) @rgb(9, 79, 164)
	{%table3}.settextcolor(1) white
	{%table3}.setlines(@all) +a
	
	if check2=1 then
		%table4="Coherence_Data"
		if @isobject(%table4) then
			%table4=@getnextname(%table4)
		endif
		table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table4}
		{%table4}.setwidth(@all) 32
		{%table4}.setheight(1) 2
		{%table4}.setfillcolor(1) @rgb(9, 79, 164)
		{%table4}.settextcolor(1) white
		{%table4}.setlines(@all) +a
	endif
	
	if check3=1 then
		%table5="Gain_Data"
		if @isobject(%table5) then
			%table5=@getnextname(%table5)
		endif
		table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table5}
		{%table5}.setwidth(@all) 32
		{%table5}.setheight(1) 2
		{%table5}.setfillcolor(1) @rgb(9, 79, 164)
		{%table5}.settextcolor(1) white
		{%table5}.setlines(@all) +a
	endif
	
	if check4=1 then
		%table6="Phase_Shift_Data"
		if @isobject(%table6) then
			%table6=@getnextname(%table6)
		endif
		table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table6}
		{%table6}.setwidth(@all) 32
		{%table6}.setheight(1) 2
		{%table6}.setfillcolor(1) @rgb(9, 79, 164)
		{%table6}.settextcolor(1) white
		{%table6}.setlines(@all) +a
	endif
	
	if check5=1 then
		%table7="Phase_Spectrum_Data"
		if @isobject(%table7) then
			%table7=@getnextname(%table7)
		endif
		table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table7}
		{%table7}.setwidth(@all) 32
		{%table7}.setheight(1) 2
		{%table7}.setfillcolor(1) @rgb(9, 79, 164)
		{%table7}.settextcolor(1) white
		{%table7}.setlines(@all) +a
	endif
	
	if check6=1 then
		%table8="Amplitude_Data"
		if @isobject(%table8) then
			%table8=@getnextname(%table8)
		endif
		table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table8}
		{%table8}.setwidth(@all) 32
		{%table8}.setheight(1) 2
		{%table8}.setfillcolor(1) @rgb(9, 79, 164)
		{%table8}.settextcolor(1) white
		{%table8}.setlines(@all) +a
	endif
	
	if check7=1 then
		%table9="Cospectrum_Data"
		if @isobject(%table9) then
			%table9=@getnextname(%table9)
		endif
		table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table9}
		{%table9}.setwidth(@all) 32
		{%table9}.setheight(1) 2
		{%table9}.setfillcolor(1) @rgb(9, 79, 164)
		{%table9}.settextcolor(1) white
		{%table9}.setlines(@all) +a
	endif
	
	if check8=1 then
		%table10="Quadrature_Data"
		if @isobject(%table10) then
			%table10=@getnextname(%table10)
		endif
		table(@obsrange/2+1,@columns({%name})*@columns({%name})) {%table10}
		{%table10}.setwidth(@all) 32
		{%table10}.setheight(1) 2
		{%table10}.setfillcolor(1) @rgb(9, 79, 164)
		{%table10}.settextcolor(1) white
		{%table10}.setlines(@all) +a
	endif
	
	!z=0
	for !l=1 to @columns({%name})
		for !h=1 to @columns({%name})
			!z=!z+1
			%l=@str(!l)
			%h=@str(!h)
			%w="Angular Frequency (Omega)"
			{%table1}(1,!z)=%w+"_"+%l+"_"+%h
			%frequency="Frequency (Cycle/Unit time)"
			{%table2}(1,!z)=%frequency+"_"+%l+"_"+%h
			%cycle_frequency="Cycle frequency (Time Unit/Cycle)"
			{%table3}(1,!z)=%cycle_frequency+"_"+%l+"_"+%h
			if check2=1 then
				%Coherence="Coherence"
				{%table4}(1,!z)=%Coherence+"_"+%l+"_"+%h
			endif
			if check3=1 then
				%Gain="Gain Function"
				{%table5}(1,!z)=%Gain+"_"+%l+"_"+%h
			endif
			if check4=1 then
				%Phase_Shift="Phase Shift"
				{%table6}(1,!z)=%Phase_Shift+"_"+%l+"_"+%h
			endif
			if check5=1 then
				%Phase_Spectrum="Phase Spectrum"
				{%table7}(1,!z)=%Phase_Spectrum+"_"+%l+"_"+%h
			endif
			if check6=1 then
				%Amplitude="Amplitude Spectrum"
				{%table8}(1,!z)=%Amplitude+"_"+%l+"_"+%h
			endif
			if check7=1 then
				%Cospectrum="Cospectrum"
				{%table9}(1,!z)=%Cospectrum+"_"+%l+"_"+%h
			endif
			if check8=1 then
				%Quadrature="Quadrature Spectrum"
				{%table10}(1,!z)=%Quadrature+"_"+%l+"_"+%h
			endif
			for !i=1 to @obs(angular_!l_!h) 'All functions for the lth and hth variables have the same number of observations than the angular frequency for the lth and hth variables
				{%table1}(!i+1,!z)=angular_!l_!h(!i)
				{%table2}(!i+1,!z)=frequency_!l_!h(!i)
				if !i=1 then
					{%table3}(!i+1,!z)="Zero frequency"
				else
					{%table3}(!i+1,!z)=1/frequency_!l_!h(!i)
				endif
				if check2=1 then
					{%table4}(!i+1,!z)=coherence_!l_!h(!i)
				endif
				if check3=1 then
					{%table5}(!i+1,!z)=gain_!l_!h(!i)
				endif
				if check4=1 then
					{%table6}(!i+1,!z)=phase_shift_!l_!h(!i)
				endif
				if check5=1 then
					{%table7}(!i+1,!z)=phase_!l_!h(!i)
				endif
				if check6=1 then
					{%table8}(!i+1,!z)=A_!l_!h(!i)
				endif
				if check7=1 then
					{%table9}(!i+1,!z)=cospectrum1_!l_!h(!i)
				endif
				if check8=1 then
					{%table10}(!i+1,!z)=quadrature1_!l_!h(!i)
				endif
			next
		next
	next


	{%spool2}.insert(name={%table1}) {%table1}
	if check10=1 then
		%text_1="Angular Frequency using "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Angular Frequency using "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool2}.comment {%table1} %text_1
	
	{%spool2}.insert(name={%table2}) {%table2}
	if check10=1 then
		%text_1="Frequency using "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Frequency using "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool2}.comment {%table2} %text_1
	
	{%spool2}.insert(name={%table3}) {%table3}
	if check10=1 then
		%text_1="Cycle Frequency using "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
	else
		%text_1="Cycle Frequency using "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
	endif
	{%spool2}.comment {%table3} %text_1
	
	if check2=1 then
		{%spool2}.insert(name={%table4}) {%table4}
		if check10=1 then
			%text_1="Coherence on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
		else
			%text_1="Coherence on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
		endif
		{%spool2}.comment {%table4} %text_1
	endif
	
	if check3=1 then
		{%spool2}.insert(name={%table5}) {%table5}
		if check10=1 then
			%text_1="Gain Function on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
		else
			%text_1="Gain Function on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
		endif
		{%spool2}.comment {%table5} %text_1
	endif
	
	if check4=1 then
		{%spool2}.insert(name={%table6}) {%table6}
		if check10=1 then
			%text_1="Phase Shift Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
		else
			%text_1="Phase Shift Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
		endif
		{%spool2}.comment {%table6} %text_1
	endif
	
	if check5=1 then
		{%spool2}.insert(name={%table7}) {%table7}
		if check10=1 then
			%text_1="Phase Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
		else
			%text_1="Phase Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
		endif
		{%spool2}.comment {%table7} %text_1
	endif
	
	if check6=1 then
		{%spool2}.insert(name={%table8}) {%table8}
		if check10=1 then
			%text_1="Amplitude Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
		else
			%text_1="Amplitude Spectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
		endif
		{%spool2}.comment {%table8} %text_1
	endif
	
	if check7=1 then
		{%spool2}.insert(name={%table9}) {%table9}
		if check10=1 then
			%text_1="Cospectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
		else
			%text_1="Cospectrum on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
		endif
		{%spool2}.comment {%table9} %text_1
	endif
	
	if check8=1 then
		{%spool2}.insert(name={%table10}) {%table10}
		if check10=1 then
			%text_1="Quadrature on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window+"\nLag and Lead for bias correction: ("+%lag_lead+")"
		else
			%text_1="Quadrature on "+%name+" | Truncation point: "+%Bandwidth+" | Window: " +%choosen_window
		endif
		{%spool2}.comment {%table10} %text_1
	endif
	
	'Delete series and tables remaining
	
	delete {%table1} {%table2} {%table3} {%table4} {%table5} {%table6} {%table7} {%table8} {%table9} {%table10}
endif

for !l=1 to @columns({%name})
	for !h=1 to @columns({%name})
		if check2=1 then
			delete coherence_!l_!h
		endif
		if check3=1 then
			delete gain_!l_!h
		endif
		if check4=1 then
			delete phase_shift_!l_!h 
		endif
		if check6=1 or check2=1 or check3=1 then
			delete A_!l_!h
		endif
		if check5=1 or check4=1 then
			delete phase_!l_!h
		endif
		delete cospectrum1_!l_!h quadrature1_!l_!h frequency_!l_!h angular_!l_!h
	next
next

delete check1 check2 check3 check4 check5 check6 check7 check8 check9 check10
'-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'---------------------------------------------------------Cospectrum and Quadrature spectrum subroutine-------------------------------------------------------
'-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
subroutine local cross_spectra(group group,vector cospectrum,vector quadrature,vector w,vector frec,scalar check1,scalar !l,scalar !h, scalar !M,scalar check10,scalar !LAG_LEAD)
%first="x"
%last="y"

if @isobject(%first) then 
	%first=@getnextname(%first)
endif

if @isobject(%last) then 
	%last=@getnextname(%last)
endif

genr {%first}=group(!l)
genr {%last}=group(!h)
'Sample
scalar n1=@obs({%first})
scalar n2=@obs({%last})
!n=n1

if n1<=n2 then
  !n=n1
  else
  !n=n2
endif

if check10=1 and !l<>!h then  'if the bias correction is requested

vector(!M,1) cross1
vector(!M,1) cross2
series product1=({%first}-@mean({%first}))*({%last}-@mean({%last}))
series product2=0  'Dont repeat correlation at zero lag
cross1(1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
cross2(1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))

for !i=1 to !M-1
      product1=({%first}-@mean({%first}))*({%last}(-!i)-@mean({%last}(-!i)))
      cross1(!i+1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
      product2=({%first}-@mean({%first}))*({%last}(!i)-@mean({%last}(!i)))
      cross2(!i+1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
next

for !i=1 to !M
   scalar max1_cc=@max(@abs(cross1))
   scalar max2_cc=@max(@abs(cross2))
   if max1_cc>max2_cc then
   if cross1(!i)=max1_cc then
   !LAG_LEAD=-!i+1 'Because the vector contains the zero lag
   endif
   else
   if cross2(!i)=max2_cc then
   !LAG_LEAD=!i-1 'Because the vector contains the zero lag
   endif
   endif
next

%last_lead_lag="z"

if @isobject(%last_lead_lag) then 
	%last_lead_lag=@getnextname(%last_lead_lag)
endif

genr {%last_lead_lag}={%last}(!LAG_LEAD)
{%last}={%last_lead_lag} 'the last series is properly aligned

endif
!LAG_LEAG=0  'If the correction is not requested the LAG/LEAD would be zero.

'Cross correlation and weighting window
'----------------------------------------------------------------------------Rectangular------------------------------------------------------------------------------------
if check1=5 then

'Fourier frequencys
!loop=0
for !i=0 to !n/2
    !q=!i
	!loop=!loop+1
    vector(!n/2+1,1) w(!loop,1)=(2*@acos(-1)*!q)/!n
    vector(!n/2+1,1) frec(!loop,1)=w(!loop,1)/(2*@acos(-1))
next

for !j=1 to !n/2+1
      for !i=1 to !M
            matrix(!n/2+1,!M) coseno(!j,!i)=@cos(w(!j,1)*!i)
            matrix(!n/2+1,!M) seno(!j,!i)=@sin(w(!j,1)*!i)
      next
next

'Window
vector(1,1) cross0
vector(!M,1) cross1
vector(!M,1) cross2
series product1=({%first}-@mean({%first}))*({%last}-@mean({%last}))
series product2=({%first}-@mean({%first}))*({%last}-@mean({%last}))
cross0(1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))

for !i=1 to !M
      product1=({%first}-@mean({%first}))*({%last}(-!i)-@mean({%last}(-!i)))
      cross1(!i,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
      product2=({%first}-@mean({%first}))*({%last}(!i)-@mean({%last}(!i)))
      cross2(!i,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
next

'Cospectrum and quadrature spectrum
vector(!n/2+1,1) cospectrum
vector(!n/2+1,1) quadrature
vector prov=na
for !i=1 to !n/2+1
          prov=cross0+@rowextract(coseno,!i)*(cross1+cross2)
          cospectrum(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
          prov=@rowextract(seno,!i)*(cross2+cross1)
          quadrature(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
next

endif
'------------------------------------------------------------------------------Bartlett----------------------------------------------------------------------------------------
if check1=3 then

'Fourier frequencys
!loop=0
for !i=0 to !n/2
    !q=!i
	!loop=!loop+1
    vector(!n/2+1,1) w(!loop,1)=(2*@acos(-1)*!q)/!n
    vector(!n/2+1,1) frec(!loop,1)=w(!loop,1)/(2*@acos(-1))
next

for !j=1 to !n/2+1
      for !i=1 to !M
            matrix(!n/2+1,!M) coseno(!j,!i)=@cos(w(!j,1)*!i)
            matrix(!n/2+1,!M) seno(!j,!i)=@sin(w(!j,1)*!i)
      next
next

'Window
vector(!M+1) bartlett
for !i=1 to !M+1
     bartlett(!i)=1-@abs(!i-1)/!M
next

vector(!M,1) cross1 
vector(!M,1) cross2 
series product1=({%first}-@mean({%first}))*({%last}-@mean({%last}))
series product2=0  'Dont repeat correlation at zero lag
cross1(1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
cross2(1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))

for !i=1 to !M-1 
      product1=({%first}-@mean({%first}))*({%last}(-!i)-@mean({%last}(-!i)))
      cross1(!i+1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
      product2=({%first}-@mean({%first}))*({%last}(!i)-@mean({%last}(!i)))
      cross2(!i+1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
next

'Weighting window
for !i=1 to !M 
      cross1(!i)=bartlett(!i)*cross1(!i)
      cross2(!i)=bartlett(!i)*cross2(!i)
next

'Cospectrum and quadrature spectrum
vector(!n/2+1,1) cospectrum 
vector(!n/2+1,1) quadrature 
vector prov=na

for !i=1 to !n/2+1
          prov=@rowextract(coseno,!i)*(cross1+cross2)
          cospectrum(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
          prov=@rowextract(seno,!i)*(cross2+cross1)
          quadrature(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
next
endif
'---------------------------------------------------------------------------Hamming---------------------------------------------------------------------------------
if check1=1 then
	
	'Fourier frequencys
	!loop=0
	for !i=0 to !n/2
    		!q=!i
		!loop=!loop+1
    		vector(!n/2+1,1) w(!loop,1)=(2*@acos(-1)*!q)/!n
    		vector(!n/2+1,1) frec(!loop,1)=w(!loop,1)/(2*@acos(-1))
	next

	for !j=1 to !n/2+1
    		  for !i=1 to !M
         	    matrix(!n/2+1,!M) coseno(!j,!i)=@cos(w(!j,1)*!i)
           	 	matrix(!n/2+1,!M) seno(!j,!i)=@sin(w(!j,1)*!i)
      	  next
	next
	
	'Window
	vector(!M+1) hamming
	for !i=1 to !M+1
		hamming(!i)=1-2*0.23+2*0.23*@cos(@acos(-1)*(!i-1)/!M)
	next
	
	vector(!M,1) cross1
	vector(!M,1) cross2
	series product1=({%first}-@mean({%first}))*({%last}-@mean({%last}))
	series product2=0  'Dont repeat correlation at zero lag
	cross1(1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	cross2(1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	
	for !i=1 to !M-1
		product1=({%first}-@mean({%first}))*({%last}(-!i)-@mean({%last}(-!i)))
		cross1(!i+1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
		product2=({%first}-@mean({%first}))*({%last}(!i)-@mean({%last}(!i)))
		cross2(!i+1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	next
	
	'Weighting window
	for !i=1 to !M
		cross1(!i)=hamming(!i)*cross1(!i)
		cross2(!i)=hamming(!i)*cross2(!i)
	next
	
	'Cospectrum and quadrature spectrum
	vector(!n/2+1,1) cospectrum
	vector(!n/2+1,1) quadrature
	vector prov=na
	
	for !i=1 to !n/2+1
		prov=@rowextract(coseno,!i)*(cross1+cross2)
		cospectrum(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
		prov=@rowextract(seno,!i)*(cross2+cross1)
		quadrature(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
	next
endif
'-----------------------------------------------------------------------------Hann-----------------------------------------------------------------------------------
if check1=2 then
	
	'Fourier frequencys
	!loop=0
	for !i=0 to !n/2
    		!q=!i
		!loop=!loop+1
    		vector(!n/2+1,1) w(!loop,1)=(2*@acos(-1)*!q)/!n
    		vector(!n/2+1,1) frec(!loop,1)=w(!loop,1)/(2*@acos(-1))
	next

	for !j=1 to !n/2+1
    		  for !i=1 to !M
         	    matrix(!n/2+1,!M) coseno(!j,!i)=@cos(w(!j,1)*!i)
           	 	matrix(!n/2+1,!M) seno(!j,!i)=@sin(w(!j,1)*!i)
      	  next
	next
	
	'Window
	vector(!M+1) hann
	for !i=1 to !M+1
		hann(!i)=1-2*0.25+2*0.25*@cos(@acos(-1)*(!i-1)/!M)
	next
	
	vector(!M,1) cross1
	vector(!M,1) cross2
	series product1=({%first}-@mean({%first}))*({%last}-@mean({%last}))
	series product2=0  'Dont repeat correlation at zero lag
	cross1(1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	cross2(1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	
	for !i=1 to !M-1
		product1=({%first}-@mean({%first}))*({%last}(-!i)-@mean({%last}(-!i)))
		cross1(!i+1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
		product2=({%first}-@mean({%first}))*({%last}(!i)-@mean({%last}(!i)))
		cross2(!i+1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	next
	
	'Weighting window
	for !i=1 to !M
		cross1(!i)=hann(!i)*cross1(!i)
		cross2(!i)=hann(!i)*cross2(!i)
	next
	
	'Cospectrum and quadrature spectrum
	vector(!n/2+1,1) cospectrum
	vector(!n/2+1,1) quadrature
	vector prov=na
	
	for !i=1 to !n/2+1
		prov=@rowextract(coseno,!i)*(cross1+cross2)
		cospectrum(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
		prov=@rowextract(seno,!i)*(cross2+cross1)
		quadrature(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
	next
endif
'-----------------------------------------------------------------------------Parzen--------------------------------------------------------------------------------------
if check1=4 then
	
	'Fourier frequencys
	!loop=0
	for !i=0 to !n/2
    		!q=!i
		!loop=!loop+1
    		vector(!n/2+1,1) w(!loop,1)=(2*@acos(-1)*!q)/!n
    		vector(!n/2+1,1) frec(!loop,1)=w(!loop,1)/(2*@acos(-1))
	next

	for !j=1 to !n/2+1
    		  for !i=1 to !M
         	    matrix(!n/2+1,!M) coseno(!j,!i)=@cos(w(!j,1)*!i)
           	 	matrix(!n/2+1,!M) seno(!j,!i)=@sin(w(!j,1)*!i)
      	  next
	next
	
	'Window
	vector(!M+1) parzen
	for !i=1 to !M+1
		if !i<=!M/2 then
			parzen(!i)=1-6*((!i-1)/!M)^2+6*(@abs(!i-1)/!M)^3
		else
			parzen(!i)=2*(1-@abs(!i-1)/!M)^3
		endif
	next
	
	vector(!M,1) cross1
	vector(!M,1) cross2
	series product1=({%first}-@mean({%first}))*({%last}-@mean({%last}))
	series product2=0  'Dont repeat correlation at zero lag
	cross1(1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	cross2(1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	
	for !i=1 to !M-1
		product1=({%first}-@mean({%first}))*({%last}(-!i)-@mean({%last}(-!i)))
		cross1(!i+1,1)=(@sum(product1)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
		product2=({%first}-@mean({%first}))*({%last}(!i)-@mean({%last}(!i)))
		cross2(!i+1,1)=(@sum(product2)/(!n))/(@stdevp({%first}-@mean({%first}))*@stdevp({%last}-@mean({%last})))
	next
	
	'Weighting window
	for !i=1 to !M
		cross1(!i)=parzen(!i)*cross1(!i)
		cross2(!i)=parzen(!i)*cross2(!i)
	next
	
	'Cospectrum and quadrature spectrum
	vector(!n/2+1,1) cospectrum
	vector(!n/2+1,1) quadrature
	vector prov=na
	
	for !i=1 to !n/2+1
		prov=@rowextract(coseno,!i)*(cross1+cross2)
		cospectrum(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
		prov=@rowextract(seno,!i)*(cross2-cross1)
		quadrature(!i,1)=(1/(2*@acos(-1)))*prov(1,1)
	next
endif
endsub
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------


